{% extends "baseAjaxTable.html" %}
{% block content %}

<button  data-toggle="modal" class="btn btn-danger btn-del" data-target="#modalSupprimer">Supprimer la ligne</button>
<button type="button" class="btn btn-secondary btn-add" data-toggle="modal" data-target="#ModalClientForm"> Ajouter un Client</button>
<button type="button" class="btn btn-secondary btn-edit" data-toggle="modal" data-target="#ModalModifClientForm"> Modifier le Client</button>
<button type="button" id="btn-filtre" class="btn btn-secondary" data-toggle="modal" data-target="#ModalClientFormFiltre"> Filtrer</button>


  <table id="data" class="table table-striped display table-bordered">
    <thead>
      <tr>
        <th>ID</th>
        <th>Nom</th>
        <th>Prenom</th>
        <th>Age</th>
        <th>Poids</th>
        <th>Num Tel</th>
        <th>Costisation</th>
      </tr>
    </thead>
    <tbody>

    </tbody>
  </table>
  <!--Modal s'affichant lors du clique de supprimer pour savoir si on veut vraiment supprimer-->
  <div class="modal fade" id="modalSupprimer" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Supprimer</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <p>Etes-vous sur de vouloir supprimer ce Client ?</p>
          <span id="clientsup"></span>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
          <button type="button" class="btn btn-danger" id="deleteClient" data-dismiss="modal">Supprimer</button>
          
        </div>
      </div>
    </div>
</div>


<div id="ModalClientForm" class="modal fade modal-client" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Ajouter un Client</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST", action="{{  url_for("save_client") }}">
                {{ form.hidden_tag() }}
                {% for field in form.get_form_field() %}
                    {% if form[field].type == 'SelectField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% elif form[field].type == 'BooleanField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} "">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% else %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form[field].errors %}
                        <ul class="list-group">
                            {% for e in form[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <input type="submit" class="btn btn-primary" value="Ajouter">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->

<div id="ModalModifClientForm" class="modal fade modal-client" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Modifier le Client</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST", action="{{  url_for("edit_client") }}">
                {{ form.hidden_tag() }}
                {% for field in form.get_form_field() %}
                    {% if form[field].type == 'SelectField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} selectFieldClasse2" style="width: 75%">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% elif form[field].type == 'BooleanField' %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %} "">
                            {{ form[field].label }} {{ form[field](size=1) }}
                        </div>
                    {% else %}
                        <div class="form-group{% if form[field].errors %} has-error{% endif %}">
                            {{ form[field].label }} {{ form[field](size=50, class_="form-control") }}
                        </div>
                    {% endif %}
                    {% if form[field].errors %}
                        <ul class="list-group">
                            {% for e in form[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <input type="submit" class="btn btn-primary" value="Modifier">
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->


<div id="ModalClientFormFiltre" class="modal fade modal-client" >
  <div class="modal-dialog" role="document">
      <div class="modal-content">
          <div class="modal-header">
              <h1 class="modal-title">Filtrer</h1>
          </div>
          <div class="modal-body">
              <form role="form" method="POST">
                {% for field in form_filtre.get_form_field() %}
                    <div class="form-group{% if form_filtre[field].errors %} has-error{% endif %}">
                        {{ form_filtre[field].label }} {{ form_filtre[field](size=50, class_="form-control") }}
                    </div>
                    {% if form_filtre[field].errors %}
                        <ul class="list-group">
                            {% for e in form_filtre[field].errors %}
                            <li class ="list-group-item list-group-item-danger" >{{ e }} </li >
                            {% endfor %}
                        </ul >
                    {% endif %}
                {% endfor %}
                <button type="button" id="btn-filtre-save" class="btn btn-secondary" data-toggle="modal" data-target="#ModalClientFormFiltre"> Filtrer</button>
              </form>      
          </div>
      </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->
 
{% endblock %}

{% block scripts %}
  <script>
    let row = null;

    $(document).ready(function(){
      let open_modal = '{{open_modal}}';
      if (open_modal) {
        $('#ModalClientForm').modal('show');
      }
      let open_modal_edit = '{{open_modal_edit}}';
      if (open_modal_edit) {
        $('#ModalModifClientForm').modal('show');
      }
      
      $(".btn-edit").prop("disabled",true);
      $(".btn-del").prop("disabled",true);
      let table = $('#data').DataTable({
        ajax:{
              url:'/api/data/client',
                type:"POST",
                data:function(client1){
                    if(client1!=undefined){
                      client1.prenom_personne_filtre = $("#prenom_personne_filtre").val();
                      client1.nom_personne_filtre = $("#nom_personne_filtre").val();
                      client1.age_personne_filtre = $("#age_personne_filtre").val();
                      client1.poids_filtre = $("#poids_filtre").val();
                      client1.num_tel_filtre = $("#num_tel_filtre").val();
                      client1.cotisation_filtre = $("#cotisation_filtre").val();
                  }
                  return client1
                }
        },
        columns: [
          {data: 'id'},
          {data: 'nom_personne', searchable: true, orderable:true},
          {data: 'prenom_personne', searchable: true, orderable:true},
          {data: 'age_personne', searchable: false, orderable:true},
          {data: 'poids', searchable: false, orderable:true},
          {data: 'num_tel', searchable: true, orderable:true},
          {data: 'cotisation', searchable: true}
        ],
      
        
      });

       $("#data").on("click", "tr", function() {
            if(row !=null){
                $(row).css('background-color', "");     
            }
            $(".btn-edit").prop("disabled",false);
            $(".btn-del").prop("disabled",false);
            row = this;
            $(this).css('background-color', "#AFE1AF");
            $("#clientsupprimer").html($(row)[0].childNodes[1].innerHTML+ " " + $(row)[0].childNodes[2].innerHTML)
        });

        $("#deleteClient").on("click",function(){
            $.ajax({
                url:'{{url_for("delete_client")}}',
                type:'POST',
                data:{id:$(row)[0].childNodes[0].innerHTML},
            success: function(){
                table.ajax.reload();
                } 
            });       
        });

        $("#data").on("dblclick", "tr", function() {
          row = this;
          let idClient = row.childNodes[0].innerHTML;
          window.location.href = "{{ url_for('detail_client', id='idClient') }}".replace("idClient",idClient) ;
        });

        $(document).on('click', '.btn-edit', function() {
          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation
          $('#ModalModifClientForm #id').val($(row)[0].childNodes[0].innerHTML);
          $('#ModalModifClientForm #nom_personne').val($(row)[0].childNodes[1].innerHTML);
          $('#ModalModifClientForm #prenom_personne').val($(row)[0].childNodes[2].innerHTML);
          $('#ModalModifClientForm #age_personne').val($(row)[0].childNodes[3].innerHTML);
          $('#ModalModifClientForm #poids').val($(row)[0].childNodes[4].innerHTML);
          $('#ModalModifClientForm #num_tel').val($(row)[0].childNodes[5].innerHTML);
          if($(row)[0].childNodes[6].innerHTML == "true")
              $('#ModalModifClientForm #cotisation').prop('checked', true);
          else
              $('#ModalModifClientForm #cotisation').prop('checked', false);
          // Afficher le modal
          $('#ModalModifClientForm').modal('show');
        });

        $(document).on('click', '.btn-add', function() {
          // Récupérer les informations de la réservation avec l'id spécifié
          // Préremplir les champs de formulaire dans le modal avec les informations de la réservation
          $('#ModalClientForm #id').val("");
          $('#ModalClientForm #nom_personne').val("");
          $('#ModalClientForm #prenom_personne').val("");
          $('#ModalClientForm #age_personne').val("");
          $('#ModalClientForm #poids').val("");
          $('#ModalClientForm #num_tel').val("");
          $('#ModalClientForm #cotisation').prop('checked', false);
          // Afficher le modal
          $('#ModalClientForm').modal('show');

          let errorElements = document.getElementsByClassName("list-group-item-danger");

          // Loop through the elements and remove the li element
          while(errorElements.length > 0){
            errorElements[0].parentNode.removeChild(errorElements[0]);
          }
          
        });
     
        $("#btn-filtre-save").on("click",function(){
          table.ajax.reload();
          $("#ModalClientFormFiltre").modal("hide");
        });
        $("#btn-filtre").on("click",function(){
            $("#ModalClientFormFiltre").modal("show");
        });



    });



    
   
 



    
  </script>
{% endblock %}
<!--
  https://datatables.net/examples/api/select_single_row.html
  https://blog.miguelgrinberg.com/post/beautiful-interactive-tables-for-your-flask-templates-->